// Amuse.c 
// 
// practicum OOP 1994 door M. van Welie & B. Schonhage
//
// Main program for the Advanced MUsical Score Editor (AMUSE)

#include <new.h>
#include <hush/unistd.h>
#include <hush/session.h>
#include <amuse/ScoreEditor.h>
#include <amuse/ScoreCanvas.h>
#include <extern/amuse.h>

void NoMem(void)
{
   	cerr << "ERROR: new failed, program aborts"<<endl;
   	_exit(1);
}

class application : public session {
    public:
	application(int argc, char** argv,char *Name) :
		session(argc,argv,Name) {}
	
	void prelude() {
		init_amuse(tk);
	}

	int main() {
		tk->trace(0);
		set_new_handler(&NoMem);
		sc = new ScoreEditor(".amuse");
		sc->pack("-fill both -expand true");
 		tk->eval("wm geometry . =600x700+100+100");
 		tk->eval("wm minsize . 300 300");
 		tk->eval("wm maxsize . 900 800");
		return OK;
	}
    private:
	ScoreEditor *sc;
};

int main(int argc, char **argv) {
	session *s = new application(argc,argv,"AMUSE");
	int result = s->run();
	delete s;
	session::statistics();
	return result;
}



