// eden.cc
// ExpeDiEnt midi Netserver, server of General MIDI system

#include "midiserver.h"
#include <genesis/genesis.h>

#include <stdlib.h>
#include <iostream.h>
#include <unistd.h>

const char version_string[] = "0.04";
int portnr = eden_default_port;
int eden_trace = 0;

int main(int argc, char* argv[])
{
    int argindex = 1;

    cout << "Eden - Expedient MIDI Netserver" << endl;
    cout << "version " << version_string << endl << endl;

    while (argindex < argc)
    {
        if (strcmp(argv[argindex], "-port") == 0)
        {
            argindex++;
            if (argindex >= argc)
            {
                cerr << "invalid portnumber" << endl;
                return 1;
            }
            portnr = atoi(argv[argindex]);
            argindex++;
        }
        else if (strcmp(argv[argindex], "-trace") == 0)
        {
            cerr << "Tracing is on" << endl;
            eden_trace = 1;
            argindex++;
        }
        else if (strcmp(argv[argindex], "-notrace") == 0)
        {
            cerr << "Tracing is off" << endl;
            eden_trace = 0;
            argindex++;
        }
        else
        {
            cerr << "Unknown option " << argv[argindex] << endl;
            cerr << "Possible options:" << endl;
            cerr << "    -port <portnr>" << endl;
            cerr << "    -trace" << endl;
            cerr << "    -notrace" << endl;
            return 1;
        }
    }
    
    midiserver* eden = new midiserver(portnr);
    eden -> main(argc, argv);
    delete eden;

    return 0;
}
