// midiserver.h

#ifndef _MIDISERVER_H_
#define _MIDISERVER_H_

class data_connection;
class tcp_server;
class msgparser;
class midiparser;
class devicelist;

class midiserver
{
public:
    midiserver(int portnr = 0);
    ~midiserver();

    int main(int argc, char* argv[]);
    void process(data_connection* conn, const char* msg, int msglen);

protected:
    void request_device(data_connection* conn, const char* msg, int msglen);
    void release_device(data_connection* conn, const char* msg, int msglen);
    void register_device(data_connection* conn, const char* msg, int msglen);
    void unregister_device(data_connection* conn, const char* msg, int msglen);
    void midi(data_connection* conn, const char* msg, int msglen);
    void midi_multicast(data_connection* conn, const char* msg, int msglen);

    tcp_server* server_;
    msgparser* msgparser_;
    midiparser* midiparser_;
    devicelist* devlist_;
};


#endif _MIDISERVER_H_

