// midi_device.h

#ifndef MIDI_DEVICE_H
#define MIDI_DEVICE_H

const int max_notes = 64;

#include "misc.h"
#include "patch.h"
#include "table.h"
#include "note.h"

class midi_device
{
public:
    midi_device(int fd);
    ~midi_device();
 
    void load(int pgm, char* path);
    void load_drum (int pitch, char* path);
 
    void prog_change(int ch, int pgm);

    unsigned cur() const { return current_; }
 
    void note_on(int ch, int pitch, int vol);
    void note_off(int ch, int pitch);
 
    void end_of_track();

    void play();

    void start() const;
 
private:
    int      list_[16][128];
    note*    notes_[max_notes];
    int      pgm_[16];
    long     buffer_[max_buf_size];     // mix buffer
    short    buf16_[max_buf_size];      // output buffer for 16 bits audio
    char     buf8_[max_buf_size];       // output buffer for 8 bits audio
    table*   table_;
    int      fd_;
    unsigned current_;
};
 
#endif

