// midi_in.h

#ifndef MIDI_IN_H
#define MIDI_IN_H

class midi_device;

class midi_in
{
public:
    midi_in(const char* init_file);
    ~midi_in();

    void receive_data(const char* data, int len);
    void silence();
    void reset();
    midi_device* device() { return device_; }

private:
    void note_off(int channel, char* &data);
    void note_on(int channel, char* &data);
    void pgm_change(int channel, char* &data);
    void meta_command(int command, char* &data);

    midi_device* device_;
    int fd_;
};

#endif
