// patch.cc

#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <fcntl.h>

#include "jsmidi.h"
#include "patch_info.h"
#include "sample_header.h"

#include "misc.h"
#include "patch.h"


patch::patch(int fd, int p, sample_header* sample)
{
    patch_ = (patch_info*) (new char [sizeof(patch_info) + (sample -> len)]);
 
    patch_ -> key = GUS_PATCH;
 // patch_ -> device_no = GUS_DEV;
    patch_ -> instr_no = p;
    patch_ -> mode = sample -> modes;
    patch_ -> len = sample -> len;
    patch_ -> loop_start = sample -> loop_start;
    patch_ -> loop_end = sample -> loop_end;
    patch_ -> base_note = sample -> base_note;
    patch_ -> high_note = sample -> high_note;
    patch_ -> low_note = sample -> low_note;
    patch_ -> base_freq = sample -> base_freq;
    patch_ -> detuning = sample -> detune;
    patch_ -> panning = (sample -> panning - 7) * 16;
 
    memcpy (patch_ -> env_rate, sample -> envelope_rate, 6);
    memcpy (patch_ -> env_offset, sample -> envelope_offset, 6);
 
    patch_ -> tremolo_sweep = sample -> tremolo_sweep;
    patch_ -> tremolo_rate = sample -> tremolo_rate;
    patch_ -> tremolo_depth = sample -> tremolo_depth;
 
    patch_ -> vibrato_sweep = sample -> vibrato_sweep;
    patch_ -> vibrato_rate = sample -> vibrato_rate;
    patch_ -> vibrato_depth = sample -> vibrato_depth;
 
    patch_ -> scale_frequency = sample -> scale_frequency;
    patch_ -> scale_factor = sample -> scale_factor;
 
 // patch_ -> volume = header -> master_volume;
    patch_ -> volume = 127;
 
    if (read (fd, patch_ -> data, sample -> len) != sample -> len)
    {
        fprintf (stderr, "Short file\n");
        exit (-1);
    }
    if (trace_on > 5)
        fprintf(stdout, "sample len = %ld\n", sample -> len);
    if ((patch_ -> mode) & WAVE_UNSIGNED)
    {
        if (trace_on > 5)
            fprintf(stdout, "unsigned data sample\n");
    }
    if ((patch_ -> mode) & WAVE_16_BITS)
    {
        if (trace_on > 5)
            fprintf(stdout, "16 bits sample\n");
        short* data = (short*) (patch_ -> data);
        for (int i = 0; i < ((sample -> len)>>1); i++)
        {
            data[i] = pctohs((data[i]));
            if ((patch_ -> mode) & WAVE_UNSIGNED)
            {
                data[i] = data[i] ^ (128*256);
            }
            // data[i] = (short) (sin(400.0*M_PI*i/((sample -> len)))*32000);
            // fprintf(stdout, "%6.4f\n", (float) ((float)(data[i]))/32000);
        }
    }
    else
    {
        if ((patch_ -> mode) & WAVE_UNSIGNED)
        {
            char* data = (char*) (patch_ -> data);
 
            for (int i = 0; i < (sample -> len)>>1; i++)
            {
                data[i] = data[i] ^ 128;
            }
        }
    }
}
 
 
patch::~patch()
{
    delete[] patch_;
}

