// patch.h

#ifndef PATCH_H
#define PATCH_H

#include "patch_info.h"
#include "patch_header.h"
#include "sample_header.h"

class patch
{
public:
    patch(int fd, int p, sample_header* sample);
    ~patch();
 
    int pgm() const { return patch_ -> instr_no; }
 
    long low() const { return patch_ -> low_note; }
    long high() const { return patch_ -> high_note; }
    long base() const { return patch_ -> base_note; }
 
    unsigned int sample() const { return patch_ -> base_freq; }
 
    long mode() const { return patch_ -> mode; }
 
    long loop_start() const { return patch_ -> loop_start; }
    long loop_end() const { return patch_ -> loop_end; }
 
    void* data() const { return &(patch_ -> data); }
 
private:
    patch_info* patch_;
};

#endif

