## --- demo common hush.mk
 
SHARE = ..
HUSH = ../..

CC = g++ -g -fPIC -Wall

TKFLAGS = -I$(HUSH)/include/tcl -I$(HUSH)/include/tk -I/usr/openwin/include

LIBDIRS = -L$(HUSH)/lib -R$(HUSH)/lib
HUSHLIBS = -lslush -ltcl8.0 -ltk8.0
SYSLIBS = -L/usr/openwin/lib -R/usr/openwin/lib -lX11 -lm -lsocket -lnsl -ldl

LDLIBS = -lamuse -lweb -lclient -lgenesis -lcs
LDSYS =

## LDLIBS and LDSYS are user-definable

CFLAGS = -I$(HUSH)/include 
LDFLAGS = $(LIBDIRS) $(LDLIBS) $(HUSHLIBS)  $(SYSLIBS) $(LDSYS)

.SUFFIXES: .c .cc .cpp .o .out .so .flt


.c.o:; $(CC) -c $*.c $(CFLAGS) 
.c.out: $(OBJECTS)
	$(CC) -o $*.out $*.c $(OBJECTS) $(CFLAGS) $(LDFLAGS) 

.cc.o:; $(CC) -c $*.cc $(CFLAGS) 
.cpp.out: $(OBJECTS)
	$(CC) -o $*.out $*.cc $(OBJECTS) $(CFLAGS) $(LDFLAGS) 

.cpp.o:; $(CC) -c $*.cpp $(CFLAGS) 
.cpp.out: $(OBJECTS)
	$(CC) -o $*.out $*.cpp $(OBJECTS) $(CFLAGS) $(LDFLAGS) 


## Netscape plugin support

PLUGIN = `$(HUSH)/bin/modname $*`
EVALCMD = $(HUSH)/library/eval.tcl

SOFLAGS = -DPLUGIN=$(PLUGIN) -DCOMMAND="\"init_$*\"" -DEVALCMD="\"$(EVALCMD)\""
LDPLUG = $(HUSH)/lib/slush.so


.c.so: $(OBJECTS)
	$(CC) -c $*.c $(CFLAGS) $(SOFLAGS) $(TCLTKFLAGS)
	$(CC) -G -o $*.so $*.o $(TCLPLUG) $(OBJECTS) $(LDPLUG)


.cc.so: $(OBJECTS)
	$(CC) -c $*.cc $(CFLAGS) $(SOFLAGS)
	$(CC) -G -o $*.so $*.o $(TCLPLUG) $(OBJECTS) $(LDFLAGS)

.cpp.so: $(OBJECTS)
	$(CC) -c $*.cpp $(CFLAGS) $(SOFLAGS)
	$(CC) -G -o $*.so $*.o $(TCLPLUG) $(OBJECTS) $(LDFLAGS)

