
#ifndef EXPORT_PREF_H
#define EXPORT_PREF_H

// </ignore>

#include <widgets/widgets.h>
#include <amuse/ScoreInfo.h>

class ExportPref: public toplevel {
  public:
    // Typical hush stuff:
    char* type() const { return "ExportPref"; }
    ExportPref(const char *p, ScoreInfo *s); 
    ExportPref();           
    virtual ~ExportPref();     
    virtual int operator()();  

    // Typical ExportPref stuff:
    virtual char* file(); 
    virtual char* server();
    virtual char* cookie();
    virtual int   port();
    virtual int   result();

    // Get results
    virtual int   FileExport(); // Create Midi file
    virtual int   ServerPlay(); // Server output wanted
    virtual int   ResultOK();     // Ok or Cancel selected

  protected:
    virtual void build_gui(widget* top); // set up GUI
    virtual void bindings();             // install bindings
   
  private:  
    button      *_okbutton,  *_cancelbutton, *_browsebutton;
    entry       *_fileentry, *_ipentry, *_portentry,*_cookieentry;
    label       *_filelabel, *_iplabel, *_portlabel,*_cookielabel;
    frame       *_fileframe, *_serverframe, *_buttonframe;
    checkbutton *_filecheck, *_servercheck;
    char Buffer[256],_filename[100], _servername[100], _cookie[20];
    int  _result,_port,_fileexport,_serverplay;
    ScoreInfo *SI;	
};

//<ignore>
#endif
//</ignore>
