// Key.h
//
// practicum OOP 1994 door M. van Welie & B. Schonhage
//
// Deze klasse representeert een toonsoort. Een toonsoort wordt gekenmerkt
// door een toonhoogte. Het zorgt dan zelf voor het tonen van het juiste
// aantal kruisen en mollen als het zich toont. Hierbij wordt rekening 
// gehouden met de sleutel en de notenbalk.
//

#ifndef KEY_H
#define KEY_H

#include <widgets/canvas.h>
#include <amuse/Pitch.h>
#include <amuse/Clef.h>
#include <amuse/Type.h>
#include <fstream.h>

class Staff;					// Forward declaration
class Measure;

class Key {

public:
	Key (canvas *Can, Pitch *P);
	~Key(void);

	Pitch* GetKeyPitch(void);		// Returns the pitch of the key
	void SetKeyPitch (Pitch *P);		// Sets the pitch of this key
	int GetAccidentals (void); 		// Nr of sharps/flats (+/-)

	int PitchNameAcc(PitchName P);		// Returns the alt of a basepitch in this key

	void Save(ofstream& File);
	int Load(ifstream& File);
	void Show(Staff* s, Clef* c,Measure* prev, int xpos);	// Show accidentals on canvas
	void Hide(void);			// Hide from the canvas
	int Width(Measure* Prev);			// Returns total width of all accidentals

	inline int operator==(const Key &B) const {
		return((*KeyPitch)==(*B.KeyPitch));
	}

	Key& operator=(const Key&);		// Copy constructor
private:
	Pitch *KeyPitch;
	canvas *Canvas;
	static long Counter;
	char Name[NameLength];
};

#endif

