// Note.h
//
// practicum OOP 1994 door M. van Welie & B. Schonhage
// 
// Deze klasse representeert een noot die in een maat staat. 
// Deze klasse is een object en erft dus diens members 
//

#ifndef NOTE_H
#define NOTE_H

#include <widgets/canvas.h>
#include <amuse/Object.h>
#include <amuse/Type.h>

// bij StemType 'normal' wordt door de noot zelf bepaald of de stok
// van de noot omhoog dan wel omlaag moet. Bij 'up' en 'down' wordt
// de stok geforceerd omhoog dan wel omlaag gedaan. En bij 'nostem'
// wordt er geen stok getekend.

class Note : public Object {  

public:
	Note (canvas *C,Measure *M,LengthType L);
	Note (Object &O);
	~Note (void);

        void SetPitch(Pitch *P);                // Zet de Pitch van het object
        Pitch* GetPitch(void);                  // Returns the pitch of the object
	int GetYPos(void);			// Returns the y-pos of the note

	void SetLength(LengthType NewLength);	// Set the length of the note
	LengthType GetLength(void);		// Returns the length
	void SetStem(StemType NewStem);		// Set stem up or down
	StemType GetStem(void);			// Returns the stem
	void SetPoint(PointType NewPoint);	// Set point
	PointType GetPoint(void);		// returns te point

	void Save(ofstream& File);	// Save the note
	int Load(ifstream& File);	// Load the note
	void Play(int NoteLength);			// Play a note in midi
	void Show(void);		// Show the note on the canvas
	int Width(void);		// Returns the width of the note on canvas
//	SortType Type(void);		// returns note
	ObjectType Alterations(void);

	Note& operator=(const Note &);	// assigment operator
    public:
	int TupleNote;
    private:
	Pitch *ObjectPitch;
	LengthType Length;
	StemType Stem; 
	PointType Point;
	
};

#endif
