// Pitch.h 
//
// practicum OOP 1994 door M. van Welie & B. Schonhage
//
// Deze klasse representeert een toonhoogte. Een toonhoogte is als
// volgt opgebouwd : een basis toonnaam (PitchName), het aantal verhogingen
// of verlagingen en het oktaafgetal. Een Fis2 is dus F,1,2.
//

#ifndef PITCH_H
#define PITCH_H

enum PitchName {C,D,E,F,G,A,B};			// Base pitches that pitches can have

class Pitch {

public:
	Pitch(PitchName P,int Alt,int Octave);
	~Pitch(void);

	int MidiPitch();			// Returns midi pitch
	PitchName GetBasePitch(void); 		// Returns the basepitch
	int GetAlteration(void);		// Returns the alterations
	void SetAlteration(int Alt);		// Sets the alterations
	int GetOctave(void);			// Returns the octave

	void Interval(int NrSemitones); 	// Shifts the pitch up or down 

	int operator<(const Pitch &b) const;	// a<b when a's pitch is lower than b's
	int operator>(const Pitch &b) const;	// a>b when a's pitch is higher than b's
	int operator==(const Pitch &b) const;	// a=b when they are EXACTLY the same (not tempered !)
	int operator|(const Pitch &b) const;	// the distance in semitones between a & b

private:
	PitchName Name;
	int Alteration;
	int Octave;
};

#endif

