// Rest.h
//
// practicum OOP 1994 door M. van Welie & B. Schonhage
// 
// Deze klasse representeert een noot die in een maat staat. 
// Deze klasse is een object en erft dus diens members 
//

#ifndef REST_H
#define REST_H

#include <widgets/canvas.h>
#include <amuse/Object.h>
#include <amuse/Type.h>

class Rest : public Object {  

public:
	Rest (canvas *C,Measure *M,LengthType L);
	Rest (Object &O);
	~Rest (void);

        void SetPitch(Pitch *P);                // Zet de Pitch van het object
        Pitch* GetPitch(void);                  // Returns the pitch of the object

	void SetLength(LengthType NewLength);	// Set the length of the note
	LengthType GetLength(void);		// Returns the length
        void SetPoint(PointType NewPoint);      // Set point
        PointType GetPoint(void);               // returns te point

	void Save(ofstream& File);	// Save the rest
	int Load(ifstream& File);	// Load the rest
	void Show(void);		// Show the note on the canvas
	int Width(void);		// Returns the width of the note on canvas
	SortType Type(void);		// returns rest

	Rest& operator=(const Rest&);	// assignment operator

private:
	Pitch *ObjectPitch;
	LengthType Length;
	PointType Point;
};

#endif
