// Score.h
//
// practicum OOP 1994 door M. van Welie & B. Schonhage
// 
// Deze klasse representeert een muziekstuk. Een muziekstuk bestaat uit 
// systemen die weer uit balken bestaan die weer maten bevatten.
//

#ifndef SCORE_H
#define SCORE_H

#include <hush/export.h>
#include <widgets/canvas.h>
#include <fstream.h>
#include <amuse/Lijst.h>
#include <amuse/System.h>
#include <amuse/ScoreInfo.h>
#include <amuse/Type.h>

class HUSH_API Score {
    public:
	Score();
	Score(canvas *C);
	~Score();
	
	void Calibrate ();			
	void Show();			
	void Clear();	
	void Save(ofstream& File);
	void SaveStyle(ofstream& File);
	void Load(ifstream& File);
	void LoadStyle(ifstream& File);
	void LoadMeasure(ifstream& File,int StaffNr);
	void Play(const char *filename);

	void InsertSystem(int Y,SideType Side);
	void InsertMeasure(int X, int Y,SideType Side);
	void RemoveSystem(int Y); 		
	void RemoveMeasure(int X, int Y);
	void RemoveMeasurePerSystem(int X,int Y);
	void ClearMeasure(int X, int Y);
	
	void AddObject (int X, int Y, ObjectType Type, 
			LengthType Length, StemType Stem, PointType Point);
	void DeleteObject(int X, int Y, char *Name);
	
	int InitGrouping(int X, int Y, StemType Stem);
	int AddGrouping(char *Name);
	void AcceptGrouping();
	void SetPref();
	void Default();
    protected:
	// Implementation methods
	System *SearchSystem(int Y);		
	Staff *SearchStaff(int Y);		
	Measure *SearchMeasure(int X, int Y,int &MeasureNr);
	
	// Implementation members
	lijst<System> SystemList;	
    private:
	int Top;
	Measure *GroupMeasure;
    public:
	canvas *Canvas;
	ScoreInfo* SI;
	int CHANGED;
};	

#endif
