// ScoreCanvas.h
//
// practicum OOP 1994 door M. van Welie & B. Schonhage
//
// Deze klasse is een canvas waarop een muziekstuk staat. Het handelt af
// wat er moet gebeuren als er op geklikt wordt en wanneer een cursor
// zich er in bevindt.
//

#ifndef SCORE_CANVAS_H
#define SCORE_CANVAS_H

#include <hush/export.h>
#include <widgets/canvas.h>
#include <hush/event.h>
#include <amuse/ToolBox.h>
#include <amuse/Score.h>
#include <amuse/Type.h>
#include <iostream.h>

class HUSH_API ScoreCanvas : public canvas, public Score  {
    public:
	ScoreCanvas();
//	ScoreCanvas(ToolBox *b,widget *w, char *p, char *options="");
	ScoreCanvas(const widget *w, const char *p);
	ScoreCanvas(const char *w,const char *options="");
	ScoreCanvas& operator=(ScoreCanvas const &) 
		{cerr << "OPERATOR= IN SCORECANVAS"; return *this;}

	int operator()();
	void press(event &Event);	// Handler procedures
	void motion(event &Event);
	void release(event &Event);
	void enter(event &Event);
	void setfunction(FunctionType F);
	void ExportMidi(void);
        static ToolBox *_toolbox;
    private:
	// Private methods
	int Create(kit *,int,char **argv);
	int options(kit*, int, char **argv);
	void init(const char *options="");
	int GetX(event &Event);		// Returns X coord relative to canvas
	int GetY(event &Event);		// Returns Y coord relative to canvas
	void closest(int xcoord, int ycoord);	// Uses tcl/tk closest, set id
	void ReleaseAdd(event &Event);
	void ReleaseMove(event &Event);
	void ReleaseDelete(event &Event);
	void ReleaseGroup(event &Event);
	void ReleasePref(event &Event);
    private:
	// Private members
	int x,y,OldX,OldY;
	int Moving;
	Object *Obj;	// selected object	
	int id;
	char Bitmap[NameLength];
	FunctionType Function;
	ObjectType ObjectT;
	LengthType Length;
	PointType Point;
	StemType Stem;

	canvas* me; 	// inner widget
	widget* top; 	// top widget
};
#endif
