// ScoreEditor.h
//
// practicum OOP 1994 door M. van Welie & B. Schonhage
//
// Een scorewindow is een window dat een ScoreCanvas bevat.
// Verder handelt het de menu's af
//


#ifndef SCORE_EDITOR_H
#define SCORE_EDITOR_H

#include <hush/export.h>
#include <hush/kit.h>
#include <widgets/frame.h>
#include <amuse/ScoreCanvas.h>

class HUSH_API ScoreEditor : public frame {

public:
	ScoreEditor(void);
	ScoreEditor(char *WidgetName);
	ScoreEditor(widget *w,char *WidgetName);
	~ScoreEditor(void);

	int operator()();
private:
        // Hush Widget stuff
	void BuildGUI();
	void InitBitmaps();
	int Create(kit*, int, char **argv);
        int options(kit* tcl, int argcount, char** args);
	void DefineBitmap(char *name,char *bitmap,int width,int height);
	void ShowQuit(void);
	void ShowAbout(void);
	void ShowHelp(void);
	void NewScore(void);
	void PrintScore(void);
	void OpenScore(void);
	void SaveScore(void);
	static ToolBox *_toolbox;
	char FileName[100];
	char StyleName[100];
	static long Counter;
	static long EditorCounter;

	ScoreCanvas* Canvas;
	widget* parent;
};

#endif
