// ScoreInfo.h
//
// practicum OOP 1994 door M. van Welie & B. Schonhage
//
// Deze klasse bevat een aantal parameters die algemeen zijn
// voor een Score
//

#ifndef SCOREINFO_H
#define SCOREINFO_H

#include <string.h>
#include <fstream.h>
#include <amuse/midifile.h>

class ScoreInfo {
    public:
	int	Header;		
	int 	LeftMargin;	
	int	RightMargin;
	int 	TopMargin;
	int 	BottomMargin;
	int	PageWidth;
	int 	PageHeight;
	int 	NrStaves;
	int	Tempo;
	char	Title[100];
	char	TitleFont[100];
	char	TitleAlign[100];
	char 	Composer[100];
	char 	ComposerFont[100];
	char	ComposerAlign[100];
	char    MidiFile[256];
	char	ServerName[256];
	int	Port;
	char	Cookie[20];
	midifile* Midi;
    public:
	ScoreInfo();
	~ScoreInfo();

	void DumpInfo(void);
	int Load(ifstream &File);
	void Save(ofstream &File);
};

#endif
