// Signature.h
//
// practicum OOP 1994 door M. van Welie & B. Schonhage
//
// Deze klasse representeert een signatuur. Een signatuur bestaat uit twee
// getallen ; Beats & BeatDuration. Stel signatuur 3/4 dan Beats=3, Beatduration=4
//

#ifndef SIGNATURE_H
#define SIGNATURE_H

#include <widgets/canvas.h>
#include <amuse/Type.h>
#include <fstream.h>

class Signature {

public:
	Signature (canvas* C,int NrBeats,int Duration);
	~Signature(void);

	int GetBeats(void);		// Returns the nr of beats
	void SetBeats (int B);		// Sets the nr of beats
	int GetBeatDuration (void);	// Returns the beatduration
	void SetBeatDuration (int Bd); 	// Sets the beatduration

	void Save(ofstream& File);
	int Load(ifstream& File);
	void Show(int x,int y);		// Show signature on canvas x,y
	void Hide(void);		// Hide signature from canvas
	int Width(void);		// Returns width of signature

	inline int operator==(const Signature &B) const {
	   return ((Beats==B.Beats)&&(BeatDuration==B.BeatDuration));
	}

private:
	int Beats;
	int BeatDuration;
	canvas* Canvas;
	static long Counter;
	char Name[NameLength];
};

#endif
