// System.h 
//
// practicum OOP 1994 door M. van Welie & B. Schonhage
//
// Deze klasse representeert een systeem. Een systeem bevat notenbalken.
// 

#ifndef SYSTEM_H
#define SYSTEM_H

#include <widgets/canvas.h>
#include <fstream.h>
#include <amuse/ScoreInfo.h>
#include <amuse/Type.h>
#include <amuse/Lijst.h>
#include <amuse/Staff.h>

enum AccType {accolade,bracket};

class System {
    public:
	System();		
	System (ScoreInfo *S,canvas *C, int starty=0, int nrstaves=2);
	~System ();
	
	void Calibrate(void);
	void Show();	
	void Move(int dy);	

	int GetNrStaves();	
	Staff* GetStaff(int Nr);
	Staff *SearchStaff(int Y);	
	Measure *SearchMeasure(int X, int Y,int &MeasureNr);
	
	int AddStaff(); 
	int DeleteStaff();	
	void RemoveMeasure(int MeasureNr);
	void InsertFirst(Measure* &M,int StaffNr);
	void InsertLast(Measure* &M,int StaffNr); 

	int TooWide(Measure* &M,int &StaffNr);
	int TooNarrow();
	int Size();		
	int In(int Y);		
	int GetStartY();	
	int GetEndY();	
	int GetRightBorder();
	
	// operators needed for list template
	int operator==(const System &) const;
  	int operator<(const System &) const;
    public:
	// Class members
	int CHANGED;
    protected:
	int StartY,EndY;
    private:
	static long Counter;
	char BarName[NameLength];
	char Name[NameLength];
//	int NrStaves; 			// Maybe not necessary
	AccType Accolade; 		// How are the staves grouped ?
	canvas *Canvas;
	ScoreInfo *SI;
	lijst<Staff> StaffList;
};

#endif
