// midifile.h

#ifndef _MIDIFILE_H_
#define _MIDIFILE_H_

#include <stdio.h>


class midifile
{
public:
    midifile(const char* fname, int nr_tracks);
    ~midifile();
    int isopen();
    void newtrack();
    void closetrack();
    void tempo(int bpm);
    void program(int instrument);           // instrument is 0-127
    void note_on(int note, int velocity);   // note is 0-127,
                                            // velocity is 0-127
    void note_on(int note, int velocity, int duration);   
                                            // note is 0-127,
                                            // velocity is 0-127
                                            // duration is in 1/32ths
    void note_off(int note, int velocity = 127);
    void delay(int nr_32ths);

protected:
    int encoded_deltatime(int deltatime, int& encoded);
            // returns nr of bytes needed for encoded deltatime
    void write_deltatime();

// event list functions
    class midi_event;

    void schedule_event(int time, int note, int velocity);
    void clear_list();
    midi_event* get_first_event();
    void remove_first_event();

    char* trackbuf_;
    int bufindex_;
    FILE* fd_;
    int nr_tracks_;
    int current_track_;
    int delta_time_;
    int current_time_;

    midi_event* head_;
    midi_event* current_;
    int nr_events_;
};


#endif _MIDIFILE_H_
