#ifndef _AMUSE_EXTERN_H
#define _AMUSE_EXTERN_H

#include <stdio.h>		/// for sprintf
#include <string.h>		/// for strcpy
#include <stdlib.h>		/// for getenv
#include <hush/kit.h>		/// for hush kit
#include <amuse/ScoreCanvas.h>	/// for ScoreCanvas
#include <amuse/ScoreEditor.h>	/// for ScoreEditor

void init_amuse(kit* tk) {
	// set library path
	char *lib, command[256];
    	if ((lib = getenv("AMUSE_LIB")) != NULL)  {
          sprintf(command, "set amuse_library %s", lib);
    	} else {
	   sprintf(command, "set amuse_library $hush_library/amuse");
	}
        tk->eval(command);

	// install dummy widgets
	ScoreCanvas *sc = new ScoreCanvas; tk->_register(sc);
	ScoreEditor *se = new ScoreEditor; tk->_register(se);

	tk->bind("scorecanvas", sc);
	tk->bind("amuse", se);

        // GNU g++ 2.5.8 error workaround:
        strcpy(command,"source $amuse_library/init.tcl");
        if (tk->eval(command))
		fprintf(stderr, "Could not evaluate: %s\n", command);
 
        tk->result("");
}
#endif
