// genesis_client.h

#ifndef _GENESIS_CLIENT_H_
#define _GENESIS_CLIENT_H_

#include <cs/csclient.h>
#include <genesis/devices.h>

class tcp_clientimp;
class inet_address;
class msgparser;

class genesis_client: public csclient
{
public:
    genesis_client(const char* hostname, int portnr);
    ~genesis_client();

    int request_device(int dev_type, const char* cookie = 0);
        // returns device-id, -1 if not successful
    void release_device(int dev_id);
    void send_midi(int dev_id, const char* mididata, int midilen);
    void send_midi_multicast(int* dev_ids, int nrdevs,
                             const char* mididata, int midilen);

protected:
    inet_address* address_;
    tcp_clientimp* clientimp_;
    msgparser* msgparser_;
};


#endif _GENESIS_CLIENT_H_

