// device.h

#ifndef _GENESIS_DEVICE_H_
#define _GENESIS_DEVICE_H_

#include <cs/csclient.h>
#include <genesis/devices.h>
#include <genesis/genesis.h>

class tcp_clientimp;
class inet_address;
class msgparser;
class midiparser;

class genesis_device: public csclient
{
public:
    genesis_device(const char* hostname, int portnr, int dev_type,
                   const char* desc);
        // doesn't register device
    ~genesis_device();

    virtual int register_dev();     // since 'register' is a keyword...
        // returns 1 if successful, 0 if not
    virtual void unregister();
    virtual int send_midi(const char* mididata, int midilen);
        // returns 1 if successful, 0 if not
    virtual int send_note_on(int channel, int note, int velocity);
        // returns 1 if successful, 0 if not
    virtual int send_note_off(int channel, int note, int velocity);
        // returns 1 if successful, 0 if not
    virtual int send_program(int channel, int program);
        // returns 1 if successful, 0 if not
    virtual int receive_midi(char* mididata, int maxbytes);
        // 0 if the message received was no MIDI-data message

    virtual const char* cookie();
        // returns printable string

protected:
    inet_address* address_;
    tcp_clientimp* clientimp_;
    msgparser* msgparser_;
    midiparser* midiparser_;
    char cookie_[cookie_size+1];
    int device_id_;
    int dev_type_;
    char description_[max_description_size];
};


#endif _GENESIS_DEVICE_H_
