// jamclient.h

#ifndef _JAMCLIENT_H_
#define _JAMCLIENT_H_

#include <cs/tcp/client.h>
#include <genesis/device.h>
#include <genesis/midi.h>

class msgparser;
class midiparser;

class jamclient: public tcp_client
{
public:
    jamclient(const char* outcookie = "", const char* incookie = "",
              const char* hostname = "localhost", int portnr = 27372);
    ~jamclient();

    int join();
    void leave();
    int joined();
        // 1 if joined, 0 if not
    int id();
        // returns id of connection to JamServer

    int note_on(int note, int velocity); 
        // note is 0 - 127, velocity is 0 - 127
    int note_off(int note, int velocity);
    int program(int ins);
        // ins is 0 - 127
    int drum_on(int drum, int velocity);
    int drum_off(int drum, int velocity);

    int users(char* users[midi_nr_channels]);

protected:
    char outcookie_[cookie_size];
    char incookie_[cookie_size];
    int jam_id_;
    int connected_;
    msgparser* msgp_;
    midiparser* midip_;
};


#endif _JAMCLIENT_H_

