// midiparser.h

// NOTE: all channel numbers are 0-based!

#ifndef _MIDIPARSER_H_
#define _MIDIPARSER_H_


class midiparser
{
public:
/* Creating MIDI-messages: */
// Channel Voice Messages
    int create_note_off(char* msg, int chan, int note, int velocity) const;
    int create_note_on(char* msg, int chan, int note, int velocity) const;
    //int create_key_pressure(char *msg, int chan, int note, 
    //                        int velocity) const;
    //int create_control(char* msg, int chan, int ctrl, 
    //                   int value) const;
    int create_program(char* msg, int chan, int program) const;
    //int create_channel_pressure(char* msg, int chan, 
    //                            int velocity) const;
    //int create_pitch_wheel(char* msg, int chan, int value) const;

// System Common Messages
    //int create_sysex(char* msg, const char* orgmsg, int orgsize, 
    //                 int midi_id) const;
    //int create_song_posptr(char* msg, int pos) const;
    //int create_song_select(char* msg, int song) const;
    //int create_tune_request(char* msg) const;

// System Real-Time Messages
    //int create_timing_clock(char* msg) const;
    //int create_start(char* msg) const;
    //int create_continue(char* msg) const;
    //int create_stop(char* msg) const;
    //int create_active_sensing(char* msg) const;
    //int create_reset(char* msg) const;

/* Parsing MIDI-messages */

    int type(const char* msg) const;
    int channel(const char* msg) const;
    int note(const char* msg) const;
    int velocity(const char* msg) const;
    int program(const char* msg) const;

// Channel Voice Messages
    void parse_note_off(const char* msg, int& chan, int& note, 
                        int& velocity) const;
    void parse_note_on(const char* msg, int& chan, int& note, 
                       int& velocity) const;
    //void parse_key_pressure(const char *msg, int& chan, int& note, 
    //                        int& velocity) const;
    //void parse_control(const char* msg, int& chan, int& ctrl, 
    //                   int& value) const;
    void parse_program(const char* msg, int& chan, int& program) const;
    //void parse_channel_pressure(const char* msg, int& chan, 
    //                            int& velocity) const;
    //void parse_pitch_wheel(const char* msg, int& chan, int& value) const;

// System Common Messages
    //void parse_sysex(const char* msg, char* orgmsg, int& orgsize, 
    //                 int& midi_id) const;
    //void parse_song_posptr(const char* msg, int& pos) const;
    //void parse_song_select(const char* msg, int& song) const;

protected:
    void set_type_channel(char* msg, int type, int chan) const;
    void set_one_arg(char* msg, int arg1) const;
    void set_two_args(char* msg, int arg1, int arg2) const;
    int arg1(const char* msg) const;
    int arg2(const char* msg) const;
};


#endif _MIDIPARSER_H_
