#ifndef HUSH_CELL_H
#define HUSH_CELL_H

#include <hush/export.h>

class HUSH_API dvcell_type { 
public:
  dvcell_type() {}
  ~dvcell_type() {}
};

#include <hush/iter.h>

class HUSH_API dvcell {  
public:
	 dvcell(const void* x = 0, dvcell* y = 0);
	 ~dvcell();
	 dvcell* first() const;
	 dvcell* last() const;
	 int length() const;
	 int contains(void *p) const;
	 dvcell* find(void* ) const;
	 dvcell* insert(const void* e, const dvcell_type* me = 0);
	 dvcell* remove(const void* e = 0, const dvcell_type* me = 0);
public:
 void* el; 
 dvcell* next;
 dvcell* prev;
 int refs;
public:
 static int created;
 static int deleted;
};

class dvcelliter : public iter<void> {
public:
 dvcelliter(dvcell* c);
 ~dvcelliter();
 void* operator()();
private:
 dvcell* p;
};

#ifndef cell
#define cell dvcell
#endif

#ifndef celliter
#define celliter dvcelliter
#endif

#endif
