///The session class is needed to start
///the X main loop.
///It is also used in the simulation package.
////See man:session(4), <hush/handler.h>

#ifndef SESSION_H
#define SESSION_H

#include <hush/export.h>
#include <hush/handler.h>

class kit;

class HUSH_API session : public handler  {
  protected:
    session(const char* kind = "default" );
    session(session*);
  public:
    session(int argc, char* argv[], const char* name = "hush", int fl=0);
    // putting 0 for name disables window mapping	

    virtual int create(int , char**, const char*, int fl); // for subs
    
    virtual ~session();

    virtual int tracelevel() const;
    virtual void  trace(int = 1);
    
    virtual void prelude();
    virtual int main();
    
    virtual int run( int proc(class kit*,int,char**) = 0 );
    
    //protected: // for experienced users only
    
    virtual void init(const char* fname, void* = 0);
    virtual void install(void* = 0);
    
    virtual int mode() const;
    virtual int mode(int fl);
    virtual int mode(const char* = 0);
    
    virtual int loop(int fl=0);
    virtual int body(int fl=0);
    
    virtual void map(int fl=0); // redefine map to disable window
    
    kit* thekit() const;
    
    virtual double clock() const;
    virtual double clock(double);
    
    virtual double time() const;
    virtual void time(double) { }

  private:
    void* _state;

public:
static int _trace;
static int _quit;

static int initialized;
static int initialize();


static session* _default;
static void* _create; 

static void statistics(char* s = 0);

static int created;
static int deleted;

static void* table;
static void declare(const char*, void*, int flag = 0);
static session* lookup(const char*);
static void destroy();

static char* version();
static int compilerflags();
};

//<ignore>
#endif
//</ignore>
