#ifndef DVSTRING_H
#define DVSTRING_H

#include <hush/export.h>

#include <hush/iter.h>

// TODO
// ++ -- to iterate over char or parts?
// s + int ?; s += int?
// s <<  struct ;
// A string with modalities and properties?
// lower in opslaan?


class event;
class dvstring;

class HUSH_API dvsubstring {
public:
dvsubstring(dvstring*,int,int);
~dvsubstring();
dvstring& operator=( const char* );
dvstring& operator=( char );
//operator char();
operator char*();
operator dvstring&();
private:
int pos;
int len;
dvstring* _body;
char* _str;
public:
static int created;
static int deleted;
};


class HUSH_API dvstring {
friend class dvsubstring;
public:

enum { plain = 0, argcv, pair }; /// modes

dvstring();
~dvstring();

dvstring(const char* s);  /// plain mode
dvstring(const dvstring& a);

dvstring(int argc, char** argv);  /// argcv mode
dvstring(int argc, char** argn, char** argv);  /// argcnv mode
dvstring(const event*); /// to deal with argc/argv

dvstring& clone(); /// to make a copy

dvstring& operator=( const dvstring& a );
dvstring& operator=( const char* a );

int operator==( const dvstring& a) const;
int operator==( const char* a) const;
friend int operator==( const char* s, const dvstring& a );

//// Case insensitive

int compare( const dvstring& a, int options = 1) const; /// 0 -> ==
int compare( const char* a, int options = 1) const;

int operator!=( const dvstring& a) const;
int operator!=( const char* a) const;
friend int operator!=( const char* s, const dvstring& a );
	

int operator<( const dvstring& a) const;
int operator<( const char* a) const;
friend int operator<( const char* s, const dvstring& a ) { return a < s; }

int operator<=( const dvstring& a) const;
int operator<=( const char* a) const;
friend int operator<=( const char* s, const dvstring& a ) { return a <= s; }

substr( const char* str ) const; /// -1 if not found
int match( const char* a, int opt = 0 ) const; // 1 -- nocase

//// Append -- non-destructive

dvstring operator+( const dvstring& a ) const;
dvstring operator+( const char* a ) const;
dvstring operator+( const char c ) const;

friend dvstring operator+( const char* s, const dvstring& a );
friend dvstring operator+( const char c, const dvstring& a );

//// Append - modifies string

dvstring& operator+=( const dvstring& a );
dvstring& operator+=( const char* a );
dvstring& operator+=( const char c );

//// Write to -- is like append with surrounding space


dvstring& operator<<( const dvstring& a );
dvstring& operator<<( const char* a ); 
dvstring& operator<<( const char c ); 

dvstring& operator<<( const int i );

dvstring& operator>>( int& i ) const;

int length() const;
operator char*() const;

dvsubstring& operator[](int i ) ; 
dvsubstring& operator()(int i, int len  ) ; 
					// ? mode dependent?

dvstring& _substring(int i, int j);


//<note name=argcv level=user>


int argc();
dvstring operator()(int i) { return arg(i); }

//<note mode=pair level=advanced>

int isassoc(); // test and modify (changes to pair mode)
dvstring key(); // const -- yes, no maybe ? -- I don t know
dvstring value();

//<note mode=argcv level=advanced>

dvstring& flatten(int quote=0);
dvstring& quote() { return flatten(1); }

char** convert();

//<note level=system>

dvstring arg(int i = 1) ;

char** argv( int i = 0 );
int unflatten();

//// Iteration:

operator iter<dvstring>&();

int matches(const char* str, int opt = 0); /// reg exp
int split(const char* sp); /// on char s in sp

//// Conversions -- will be put as a property in the future

dvstring& lower() const; /// result is autoregistered
dvstring& upper() const; /// result is autoregistered

void _register(iter<dvstring>*) const;
void _register(const dvstring*) const;
void _register(const dvsubstring*) const;

private:
void* _body;

public:
static int created;
static int deleted;
};

#include <iostream.h>

inline ostream& operator<<(ostream& os, const dvstring& str)
{
    os << (char*) str;
    return os;
}


#ifndef string
#define string dvstring
#endif


#endif
