#ifndef _DVSUBLIST_H
#define _DVSUBLIST_H
#pragma interface

#include <hush/private.h>


// system level usage only ...
// dvsublist allows for list assignments like
// lista(from,len) = element
// lista(from,len) = listb
// lista(from,len) = listb(from,len)

#include <hush/list.h>

template <class T>
class dvsublist : public  dvsublist_type {
public:
 dvsublist(dvlist<T>* l, int from, int len) {
	_list = l; _from = from; _len = len; 
 }

 dvlist<T>& operator=(const dvlist<T>& l) {
  	_list->_body->replace(l, _from, _len);
	return *this;
 }

 dvlist<T>& operator=(const dvsublist<T>& sl) { 	
  	_list->_body->replace(sl._list, _from, _len);
	return *this; 
 }

 dvlist<T>& operator=(const T* e) {
  	_list->_body->replace(e, _from, _len);
	return *this; 
 }

 operator dvlist<T>&() { 
	dvlist<T> *tmp = _list->range(_from, _len);
	_list->_register(tmp);
	return *tmp;
 }

private:
 dvlist<T>* _list;
 int _from, _len;
};

#endif
