include ../../cfg/install.mk

# requires DIR SRC DOC  ( index must be defined in dir ) 

IDL = $(DESTINATION)/idl

all: install
config:; @echo nothing to config

xinstall: stamp	
install: $(FILES) $(SUBDIRS)
	@echo -------- Installing include/$(DIR) ------ in $(DEST)
	@touch stamp
	@set -x; if [ $(DESTINATION) != $(LOCAL) ]; then \
	  if [ ! -d $(IDL)/$(DIR) ]; \
		then mkdir $(IDL)/$(DIR); fi; \
		  if [ ! $(IDL)/$(DIR) = `pwd` ]; then \
	             $(CP) index Makefile $(FILES) $(SUBDIRS) \
		         $(IDL)/$(DIR); fi; fi;
	@echo ======== Installing $(IDL)/$(DIR) completed ============

document = $(DOCUMENTS)/interfaces/idl/$(category)
category = $(DIR)

ht-ml = $(BIN)/ht-ml - -nomake

doc = "README index *.idl"
doc: $(DIR).doc 
	@echo -------- Documenting $(DIR)  -- in $(document) --
	if [ ! -d $(document) ]; then mkdir $(document); fi;
	export L; L=`$(files) $(doc)`; \
	for i in $$L; do $(make) $$i.html; done;
	cp *.html $(document)
	@echo ======== Documenting $(DIR) completed == in $(document)

cleandoc: clean

test:
demo:

clean:
	rm -f *.doc  *index-list *.html @* *.t
	rm -f *.bak core *.html *.dvi *.ps *.aux *.log *.tex stamp

