// browser.h
//
// a sample browser that uses the web widget
//
// Bastiaan Sch\"onhage
// 1995, 1996

#ifndef BROWSER_H
#define BROWSER_H

#include <hush/export.h>

#include <client/url.h>
#include <web/web.h>
#include <web/viewer.h>
#include <widgets/frame.h>
#include <widgets/entry.h>

class HUSH_API browser : public frame
{
      public:
	browser(); // command interface
	browser( const char* p, const char* options="" );
	browser( const widget* w, const char* p, const char* options="" );
	~browser();

	void plugin(MIME* type, viewer* v);
	void plugin(char* type, viewer* v);

	int operator()();
	void home(const char* url);

	void load(const char* url);

	void resize(int x, int y ); // promotes to web
	void geometry(int x,int y); // ae - an alias

	handler* urlhandler();
      private:
	void create( int argc, char* argv[]);
	frame* _body;
      private:
	void construct(const char* options);

	web* Www;
	url* Home;
	entry* EntryBox;
};

inline void init_browser(kit* tk) {
	handler* h = new browser();
	tk->bind("browser",h);
	tk->_register(h);
	}


#endif
