// sgml_viewer.h
//
// viewer to display SGML documents using a TCL style sheet 
// with SGML as a default,
//
// Bastiaan Schnhage
// 1995, 1996
// modified (ae)

#ifndef SGML_VIEWER_H
#define SGML_VIEWER_H

#include <hush/kit.h>
#include <widgets/text.h>
#include <web/viewer.h>

class sgml_parser;   //  viewer <-> parser  = ( scanner | handler )

class sgml_viewer : public viewer {
    public:
	sgml_viewer(handler* urlHandler); // see viewer (AE)
	virtual ~sgml_viewer();

	viewer* _create( handler* h );
	
	void map(const widget* w, const char* p);
	void unmap();

	widget* thewidget() const;
	MIME* MIMEtype() const;
	
	void display(int fd, int length, const char* info = "");
	void display_inline(int fd, int length, const MIME* type,
			    const char* info = "");
	
	int operator()();
    private:
	sgml_parser* _scan;

    public: // restricted

	void new_data(char* data, char* opts="");
	void open_element(char* tag, char* atts = "", char* opts="");
	void close_element(char* tag, char* opts="");

	void stylesheet(char* src, char* opts="");
	void pi(char* data, char* opts="");

	void applet(char* cl, char* scr, char* opts = "");


	// aux callbacks ?
	void display_image(const char* buffer, int length, const char* info);
	void display_code(const char* buffer, int length, const char* info);
	
    private:
	class text *t;    /// bad bad bad name

	void localinit(int fd);

	char Buf [20*1024];
	
	MIME* MIMYType;
	int FD;
	int PipeFD[2];

	static bool LibLoaded;
};

#endif
