// web.h
//
// header file for the web class
// web is a widget for getting, parsing en rendering web pages
//
// 1995, 1996
// Bastiaan Sch\"onhage

#ifndef WEB_H
#define WEB_H

#include <hush/export.h>
#include <hush/event.h>
#include <hush/list.h>
#include <widgets/frame.h>
#include <widgets/entry.h>
#include <widgets/message.h>
#include <widgets/scrollbar.h>
#include <web/mime-viewer.h>
#include <client/url.h>
#include <client/client.h>
#include <client/MIME.h>


class HUSH_API web: public frame {
    public:
	web();  // for the script command interface

	web(const char* p, const char* options="");
	web(const widget* w, const char* p, const char* options="");
	virtual ~web();

	void plugin(MIME* type, viewer* v);
	void plugin(char* type, viewer* v);
	void size(int width, int height);
	
	int operator()();
	
	bool load(const char* url, const char* info =0);
	bool back();
	bool forward();
	void reload();
	
	void set(entry* e);
	void set(message* m);
	void set(scrollbar* s);
	
    private:
	void create( int argc, char* argv[]);
	frame* _body;
    private:
	client* Net;
	client* ExtraNet;
	mime_viewer* Show;
	widget* ShowWidget;
	entry* EntryBox;
	message* StatusBox;
	scrollbar* Scrollbar;
	url* BaseUrl;
	slist<url> UrlList;
	
	bool become(MIME* type);
	bool do_load(const char* url, const char* info = 0);
	bool geturl(const char* url, int &fd, MIME* &type, int &length);
	void construct(const char* options);
	void error(char *s);
	void status(char* mes);
};

inline void init_web(kit* tk) {
	handler* h = new web();
	tk->bind("web",h);
	tk->_register(h);
	}

#endif
