#ifndef CHECKBUTTON_H
#define CHECKBUTTON_H

#include <widgets/export.h>

#include <widgets/button.h>

class WIDGETS_API checkbutton : public button {
public:

  char* type() const;


  checkbutton();
   
  checkbutton(const char* p, const char* opts = "", checkbutton* = 0);
  checkbutton(const widget* w, const char* p, const char* ="", checkbutton* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				const char* opts = "", widget* = 0);
   
  virtual ~checkbutton();

  virtual void variable(const char* name);
  
  virtual int value();
  virtual void toggle();
  
  virtual void select();
  
  virtual void deselect();

public: 
	checkbutton* self() const;

	checkbutton* _body() const; // virtual
	checkbutton* _context() const;
	checkbutton* _self() const;
private: 
	checkbutton* _bdy;
	int _exists() const;
	checkbutton* _this() const; // non-virtual

public: // factory

static checkbutton* _default;

static void* table;
static void declare(const char*, void*, int flag = 0);
static checkbutton* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
