#ifndef ENTRY_H
#define ENTRY_H

#include <widgets/export.h>

#include <hush/widget.h>

class WIDGETS_API entry : public widget {
public:

  char* type() const ;

  entry();
   
  entry(const char* p, const char* opts = "", entry* = 0);
  entry(const widget* w, const char* p, const char* ="", entry* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~entry();
  
  virtual void insert(const char* s);	  		/// insert s at begin
  virtual void insert(const char* s, int i);  		/// insert s at index i
  virtual void insert(const char* s, const char* i); 	/// insert s at index i
  virtual void del();			  /// delete all
  virtual void del(int from, int to=-1);  /// delete range 
  virtual void del(const char* options);  /// delete ...
  virtual char* get() const;		  /// get contents
  virtual int index(const char* i) const; /// get index of i
protected:
  void install(dvbinding* ac, const char* args="" );

public: 
	entry* self() const;

	entry* _body() const; // virtual
	entry* _context() const;
	entry* _self() const;
private: 
	entry* _bdy;
	int _exists() const;
	entry* _this() const; // non-virtual

public: // factory

static entry* _default;

static void* table;
static void declare(const char*, void*, int flag = 0);
static entry* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
