#ifndef FRAME_H
#define FRAME_H

#include <widgets/export.h>

#include <hush/widget.h>

class WIDGETS_API frame : public widget {
public:

  char* type() const ;
  
  
  frame();
   
  frame(const char* p, const char* opts = "", frame* = 0);
  frame(const widget* w, const char* p, const char* ="", frame* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~frame();
  
  virtual frame* left(widget* w, const char* options = "{left fillx filly}" );
  
  virtual frame* right(widget* w, const char* options = "{right fillx filly}" ) ;
  
  virtual void place(const char* options);


public: 
	frame* self() const;

	frame* _body() const; // virtual
	frame* _context() const;
	frame* _self() const;
private: 
	frame* _bdy;
	int _exists() const;
	frame* _this() const; // non-virtual

public: // factory

static frame* _default;

static void* table;
static void declare(const char*, void*, int flag = 0);
static frame* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
