#ifndef _HUSH_HYPERTEXT_H_
#define _HUSH_HYPERTEXT_H_

#include <widgets/export.h>

#include <hush/widget.h>

class WIDGETS_API hypertext : public widget {
public:
  char* type() const;

  hypertext();
   
  hypertext(const char* p, const char* opts = "", hypertext* = 0);
  hypertext(const widget* w, const char* p, const char* ="", hypertext* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~hypertext();

  
  virtual void file(const char* f);
  virtual void open(const char* f); // same as file
  virtual void geometry(int x, int y);
  virtual void configure(const char* s);
  
  //virtual int operator()();
  
private:
  // void init(const char* options);
  //void create(int, char**);

  //event* dispatch(event*);

public: 
	hypertext* self() const;

	hypertext* _body() const; // virtual
	hypertext* _context() const;
	hypertext* _self() const;
private: 
	hypertext* _bdy;
	int _exists() const;
	hypertext* _this() const; // non-virtual

public: // factory

static hypertext* _default;

static void* table;
static void declare(const char*, void*, int flag = 0);
static hypertext* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
