#ifndef MENUBUTTON_H
#define MENUBUTTON_H

#include <widgets/export.h>

#include <widgets/hush/button.h>
#include <widgets/hush/menu.h>

class menu;

class WIDGETS_API menubutton : public button {
public:
  
  char* type() const ;
  
  menubutton();
   
  menubutton(const char* p, const char* opts = "", menubutton* = 0);
  menubutton(const widget* w, const char* p, const char* ="", menubutton* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~menubutton();
  
  // does not support flash
  
  virtual void menu(const char* s);
  virtual void menu(class menu* m);

public: 
	menubutton* self() const;

	menubutton* _body() const; // virtual
	menubutton* _context() const;
	menubutton* _self() const;
private: 
	menubutton* _bdy;
	int _exists() const;
	menubutton* _this() const; // non-virtual

public: // factory

static menubutton* _default;

static void* table;
static void declare(const char*, void*, int flag = 0);
static menubutton* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
