#ifndef MENU_H
#define MENU_H

#include <widgets/export.h>

#include <hush/widget.h>

#include <widgets/hush/menubar.h>   /// for your convenience
#include <widgets/hush/mbutton.h>

class WIDGETS_API menu : public widget {
public:

  char* type() const ;

  menu();
   
  menu(const char* p, const char* opts = "", menu* = 0);
  menu(const widget* w, const char* p, const char* ="", menu* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~menu();
  
  virtual menu* oldadd(const char* s, const char* options = "");
  
  virtual menu* entry(const char* s, dvbinding* ac, const char* args ="", const char* options = "");
  virtual menu* entry(const char* s, const char* args ="", const char* options = "");
  
  virtual menu* add(const char* s, dvbinding* ac, const char* args ="", const char* options = "");
  virtual menu* add(const char* s, const char* args ="", const char* options = "");
  
  virtual menu* checkbutton(const char* s, const char* args = "", const char* options = "");
  virtual menu* radiobutton(const char* s, const char* var, const char* args = "", const char* options = "");
  
  virtual menu* cascade(const char* s, const char* m, const char* options = "");
  virtual menu* cascade(const char* s, menu* m, const char* options = "");
  
  virtual menu* separator(const char* options = "");
  
  virtual char* entryconfigure(int i, const char* options);
  
  virtual int index(const char *s) const ;
  
  virtual int active() const;
  
  
  virtual void del(int i);
  virtual void del(const char* s);
  
  virtual char* invoke(int i);
  virtual char* invoke(const char *s);
  
  virtual void post(int x = 500, int y = 500);
  
  virtual void unpost();

//protected: char* _name; char* _args;

void install(dvbinding* ac, const char* args);

public: 
	menu* self() const;

	menu* _body() const; // virtual
	menu* _context() const;
	menu* _self() const;
private: 
	menu* _bdy;
	int _exists() const;
	menu* _this() const; // non-virtual

public: // factory

static menu* _default;

static void* table;
static void declare(const char*, void*, int flag = 0);
static menu* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
