#ifndef MESSAGE_H
#define MESSAGE_H

#include <widgets/export.h>

#include <hush/widget.h>

class WIDGETS_API message : public widget {
public:

  char* type() const;
  
  message();
   
  message(const char* p, const char* opts = "", message* = 0);
  message(const widget* w, const char* p, const char* ="", message* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~message();
  
  virtual void text(const char* s);

public: 
	message* self() const;

	message* _body() const; // virtual
	message* _context() const;
	message* _self() const;
private: 
	message* _bdy;
	int _exists() const;
	message* _this() const; // non-virtual

public: // factory

static message* _default;

static void* table;
static void declare(const char*, void*, int flag = 0);
static message* lookup(const char*);

public: 
static int created;
static int deleted;
};
#endif
