#ifndef SCALE_H
#define SCALE_H

#include <widgets/export.h>

#include <hush/widget.h>

class WIDGETS_API scale : public widget {
public:

  char* type() const;
  
  scale();
   
  scale(const char* p, const char* opts = "", scale* = 0);
  scale(const widget* w, const char* p, const char* ="", scale* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~scale();

  
  virtual void text(const char* s);
  
  virtual void from(int n);
  virtual void to(int n);
  
  virtual int get();
  virtual void set(int v);

protected:
void install(dvbinding* ac, const char* args = "");

public: 
	scale* self() const;

	scale* _body() const; // virtual
	scale* _context() const;
	scale* _self() const;
private: 
	scale* _bdy;
	int _exists() const;
	scale* _this() const; // non-virtual

public: // factory

static scale* _default;

static void* table;
static void declare(const char*, void*, int flag = 0);
static scale* lookup(const char*);

public: 
static int created;
static int deleted;
};
#endif
