#ifndef SCROLLBAR_H
#define SCROLLBAR_H

#include <widgets/export.h>

#include <hush/widget.h>

class WIDGETS_API scrollbar : public widget {
public:

  char* type() const ;
  
  scrollbar();
   
  scrollbar(const char* p, const char* opts = "", scrollbar* = 0);
  scrollbar(const widget* w, const char* p, const char* ="", scrollbar* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~scrollbar();
  
  
  virtual void xview(widget* w); // *todo handler*
  virtual void yview(widget* w);
  
  virtual void command(widget* w, const char* option = "yview");
  virtual void command(const char* w, const char* option = "yview");
  
  virtual void orient(const char* option = "vertical");
  
  virtual int width() const { return widget::width(); }
  virtual void width(int n);
  
  virtual void get(double* r) const;

public: 
	scrollbar* self() const;

	scrollbar* _body() const; // virtual
	scrollbar* _context() const;
	scrollbar* _self() const;
private: 
	scrollbar* _bdy;
	int _exists() const;
	scrollbar* _this() const; // non-virtual

public: // factory

static scrollbar* _default;

static void* table;
static void declare(const char*, void*, int flag = 0);
static scrollbar* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
