#ifndef TEXT_H
#define TEXT_H

#include <widgets/export.h>

#include <hush/widget.h>

class WIDGETS_API text : public widget {
public:

  char* type() const;
  
  text();
   
  text(const char* p, const char* opts = "", text* = 0);
  text(const widget* w, const char* p, const char* ="", text* = 0);
   
  widget* _create(const char* p, const char* opts = "", widget* = 0);
  widget* _create(const widget* w, const char* p,
   				 const char* opts = "", widget* = 0);
   
  virtual ~text();

  virtual void insert(const char* s);
  virtual void insert(int l, int n, const char* s, const char* tags="");
  virtual void insert(const char* ind, const char* s,const char* tags="");
  
  virtual void del(int fromline, int fromcol, int toline, int tocol);
  virtual void del(const char* from ="0.0", const char* to ="end");

  virtual char* get(int fromline, int fromcol, int toline, int tocol) const;
  virtual char* get(const char* from ="0.0", const char* to ="end") const;

  virtual void enable();
  virtual void disable();
  virtual int enabled() const { return _enabled; }
protected:
  void install(dvbinding* ac, const char* args );
private:
  int _enabled;

public: 
	text* self() const;

	text* _body() const; // virtual
	text* _context() const;
	text* _self() const;
private: 
	text* _bdy;
	int _exists() const;
	text* _this() const; // non-virtual

public: // factory

static text* _default;

static void* table;
static void declare(const char*, void*, int flag = 0);
static text* lookup(const char*);

public: 
static int created;
static int deleted;
};

#endif
