#ifndef TK_ENTRY_H
#define TK_ENTRY_H

#include <widgets/tk/export.h>

#include <widgets/hush/entry.h>
#include <widgets/tk/tk.h>

class tk_entry : public entry {
public:

  
  char* category() const;

  tk_entry();
  tk_entry(const char* p, const char* options = "", entry* = 0); 
  tk_entry(const widget* w,const char* p, const char* options = "",
  entry* = 0);

  widget* _create(const char* s, const char* opts = 0,
						widget* ctx = 0);
  widget* _create(const widget* w, const char* s,
				    const char* ="", widget* =0);

  virtual ~tk_entry();
  
  void insert(const char* s);	  		/// insert s at begin
  void insert(const char* s, int i);  		/// insert s at index i
  void insert(const char* s, const char* i); 	/// insert s at index i
  void del();			  /// delete all
  void del(int from, int to=-1);  /// delete range 
  void del(const char* options);  /// delete ...
  char* get() const;		  /// get contents
  int index(const char* i) const; /// get index of i
protected:
  void install(dvbinding* ac, const char* args="" );
public:
static entry* _default;
static int initialized;
static int initialize();
};

#endif
