#ifndef TK_LISTBOX_H
#define TK_LISTBOX_H

#include <widgets/tk/export.h>

#include <widgets/hush/listbox.h>
#include <widgets/tk/tk.h>

class tk_listbox : public listbox {
  public:
    
    char* category() const;

    tk_listbox();
    tk_listbox(const char* p, const char* options ="", listbox* = 0);
    tk_listbox(const widget* w, const char* p, 
			const char* options ="", listbox* = 0);

    widget* _create(const char* s, const char* opts = 0,
						widget* ctx = 0);
    widget* _create(const widget* w, const char* s,
				    const char* ="", widget* =0);
    
    virtual ~tk_listbox();

    void insert(const char*);		// insert at end
    void insert(int index, const char*);// insert at index

    void del();				// delete all
    void del(int index);		// delete one 
    void del(int first, int last);	// delete range

    void see(int index);		// make entry visible
 
    char* get(int index) const;		// get entry 
    int size() const;			// # entries

    void select();			// select all
    void select(int first, int last);	// select range
    void unselect();			// unselect all
    void unselect(int first, int last);	// unselect range

    int selected(int index) const;	// true if entry selected
    int selection() const;		// get index of (first) 
						//    selected entry
    // todo: geometry, scanning, selecting
    
    void singleselect();
    
  protected: // virtual?
    void install(dvbinding* ac, const char* args );
    void init(const char* options);
public:
static listbox* _default;
static int initialized;
static int initialize();
};

#endif
