#ifndef TK_MENU_H
#define TK_MENU_H

#include <widgets/tk/export.h>


#include <widgets/hush/menu.h>   /// for your convenience
#include <widgets/tk/tk.h>

class tk_menu : public menu {
public:

char* category() const;

tk_menu();
tk_menu(const char* p, const char* options = "", menu* = 0);
tk_menu(const widget* w, const char* p,
			const char* options = "", menu* = 0);


widget* _create(const char* s, const char* opts = 0,
						widget* ctx = 0);
widget* _create(const widget* w, const char* s,
				    const char* ="", widget* =0);

virtual ~tk_menu();

menu* oldadd(const char* s, const char* options = "");

menu* entry(const char* s, dvbinding* ac, const char* args ="", const char* options = "");
menu* entry(const char* s, const char* args ="", const char* options = "");

menu* add(const char* s, dvbinding* ac, const char* args ="", const char* options = "");
menu* add(const char* s, const char* args ="", const char* options = "");

menu* checkbutton(const char* s, const char* args = "", const char* options = "");
menu* radiobutton(const char* s, const char* var, const char* args = "", const char* options = "");

menu* cascade(const char* s, const char* m, const char* options = "");
menu* cascade(const char* s, menu* m, const char* options = "");

menu* separator(const char* options = "");

char* entryconfigure(int i, const char* options);

int index(const char *s) const ;

int active() const;


void del(int i);
void del(const char* s);

char* invoke(int i);
char* invoke(const char *s);

void post(int x = 500, int y = 500);

void unpost();

protected:
char* _name;
char* _args;

void install(dvbinding* ac, const char* args);

public:
static menu* _default;
static int initialized;
static int initialize();
};

#endif
