#ifndef TK_TEXT_H
#define TK_TEXT_H

#include <widgets/tk/export.h>

#include <widgets/hush/text.h>
#include <widgets/tk/tk.h>

class tk_text: public text {
public:

  char* category() const;

  tk_text();
  tk_text(const char *p, const char* options = "", text* = 0);
  tk_text(const widget* w, const char *p, const char* options = "", text* = 0);

  widget* _create(const char* s, const char* opts = 0,
						widget* ctx = 0);
  widget* _create(const widget* w, const char* s,
				    const char* ="", widget* =0);

  virtual ~tk_text();
  
  virtual void insert(const char* s);
  virtual void insert(int l, int n, const char* s, const char* tags="");
  virtual void insert(const char* ind, const char* s,const char* tags="");
  
  virtual void del(int fromline, int fromcol, int toline, int tocol);
  virtual void del(const char* from ="0.0", const char* to ="end");

  virtual char* get(int fromline, int fromcol, int toline, int tocol) const;
  virtual char* get(const char* from ="0.0", const char* to ="end") const;

  virtual void enable();
  virtual void disable();
  virtual int enabled() const { return _enabled; }
protected:
  void install(dvbinding* ac, const char* args );
private:
  int _enabled;

public:
static text* _default;
static int initialized;
static int initialize();
};

#endif
