//<html>
//<h3>tk_widget.h</h3>
//Defines the abstract class <i>tk_widget</i>.
//Abstract in a general sense, not in a technical C++ sense.
//<hr>
//<a href=hush.html>hush</a>,
// tk_widget(4),
//<a href=kit.h.html>kit.h</a>,
//<a href=handler.h.html>handler.h</a>,
//<hr>
//</html>

//<ignore>
#ifndef TK_WIDGET_H
#include <hush/widget.h>

#include <widgets/tk/export.h>

void init_widgets_tk(kit*);

//</ignore>

class tk_widget : public widget {
  public:

    char* category() const;

    tk_widget();
    tk_widget(const char* s, const char* opts = "", widget* ctx = 0);
    tk_widget(const widget* w, const char* s, const char* ="", widget* =0);

    widget* _create(const char* s, const char* opts = "",
						widget* ctx = 0);
    widget* _create(const widget* w, const char* s,
				    const char* ="", widget* =0);
    
    ~tk_widget();

#endif // TK_WIDGET_H

    int eval(const char* s);
    char* evaluate(const char* s);
    
    char* title() const;	/// get/set title (toplevel)
    void title(const char*);

    
    void destroy();

    void cursor(const char*);
    void image(const char*);
   
    char* cget(const char*) const;
 
    void configure(const char* s);
    void geometry(int x, int y);
    
    widget* pack(const char* options = "-fill x" );
    widget* pack(widget* w, const char* options = "-side top -fill x -fill y" ) ;
    
    widget* pack(const char* w, const char* options );
    
    void source(const char* type, const char* args, const char* options="");
    void target(const char* type, dvbinding* ac, const char* args, const char* options="");
    
    void xscroll(const widget* s);
    void yscroll(const widget* s);
    
    void focus(const char* options = "");
    void grab(const char* options = "");
    void wait();
    
    void* tkwin() const;
    
    int width() const ;
    int height() const;

//// To install bindings


public:    direct(const char*, dvbinding*, const char* = "" );

//// And to create meta widgets
    
protected:    widget* redirect(widget* w);
public:       void alias( handler* w = 0 ); // defaults to this


#ifndef TK_WIDGET_H
protected:
	//AE: void install(dvbinding* , const char*);
	void init(const char* options);
    
public:     int operator()();

public:
    
    // obsolete

    void font(char*);
    
    void place(const char* options); // obsolete
    
    void map();
    void unmap();

public:
static widget* _default;
static int initialized;
static int initialize();
};
#define TK_WIDGET_H
#endif
//<hr> api/widgets/tk/widget.c
